"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProcessStateNamespaceInstance = exports.ProcessStateNamespace = void 0;

var _Namespace = _interopRequireDefault(require("./Namespace"));

var _JSObjectNamespace = _interopRequireDefault(require("./JSObjectNamespace"));

var _ContainerNamespace = _interopRequireDefault(require("./ContainerNamespace"));

var _SystemDataCollector = require("../../services/SystemDataCollector");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ProcessStateNamespace extends _Namespace.default {
  callMethod(name, args) {
    if (name === "dump") {
      return this.dump(args);
    }

    return new _ContainerNamespace.default();
  }

  dump() {
    let usage = _SystemDataCollector.systemDataCollector.getLastUsage();

    if (!usage) {
      return new _ContainerNamespace.default();
    }

    return new _ContainerNamespace.default({
      "CPU": new _JSObjectNamespace.default(usage.cpu),
      "GlobalCPU": new _JSObjectNamespace.default(usage.globalCpu),
      "VirtualMemorySize": new _JSObjectNamespace.default(usage.virtualMemory),
      "ProcessStartTime": new _JSObjectNamespace.default(usage.startTime),
      "SystemUpTime": new _JSObjectNamespace.default(usage.uptime)
    });
  }

}

exports.ProcessStateNamespace = ProcessStateNamespace;
const ProcessStateNamespaceInstance = new ProcessStateNamespace();
exports.ProcessStateNamespaceInstance = ProcessStateNamespaceInstance;